/*
 * -----------------------------------------------------------------------
 *
 * NOTE: Do *not* edit this file; instead, edit 'erl_alloc.types' and
 *       build again! This file was automatically generated by
 *       'make_alloc_types' on Fri Sep 27 01:16:06 2019.
 *
 * -----------------------------------------------------------------------
 *
 * 
 * Copyright Ericsson AB 2019. All Rights Reserved.
 * 
 * The contents of this file are subject to the Erlang Public License,
 * Version 1.1, (the "License"); you may not use this file except in
 * compliance with the License. You should have received a copy of the
 * Erlang Public License along with this software. If not, it can be
 * retrieved online at http://www.erlang.org/.
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 */

#ifndef ERL_ALLOC_TYPES_H__
#define ERL_ALLOC_TYPES_H__


/* --- Allocator numbers -------------------------------------------------- */

#define ERTS_ALC_A_INVALID (0)

#define ERTS_ALC_A_MIN (1)

#define ERTS_ALC_A_SYSTEM (1)
#define ERTS_ALC_A_TEMPORARY (2)
#define ERTS_ALC_A_SHORT_LIVED (3)
#define ERTS_ALC_A_STANDARD (4)
#define ERTS_ALC_A_LONG_LIVED (5)
#define ERTS_ALC_A_EHEAP (6)
#define ERTS_ALC_A_ETS (7)
#define ERTS_ALC_A_FIXED_SIZE (8)
#define ERTS_ALC_A_BINARY (9)
#define ERTS_ALC_A_DRIVER (10)

#define ERTS_ALC_A_MAX (10)


/* --- Class numbers ------------------------------------------------------ */

#define ERTS_ALC_C_INVALID (0)

#define ERTS_ALC_C_MIN (1)

#define ERTS_ALC_C_PROCESSES  (1)
#define ERTS_ALC_C_ETS  (2)
#define ERTS_ALC_C_SYSTEM  (3)
#define ERTS_ALC_C_BINARIES  (4)
#define ERTS_ALC_C_CODE  (5)
#define ERTS_ALC_C_ATOM  (6)

#define ERTS_ALC_C_MAX (6)


/* --- Type number intervals ---------------------------------------------- */

#define ERTS_ALC_N_INVALID (0)

#define ERTS_ALC_N_MIN (1)

/* Type numbers used for sys_alloc */
#define ERTS_ALC_N_MIN_A_SYSTEM (1)
#define ERTS_ALC_N_MAX_A_SYSTEM (4)

/* Type numbers used for temp_alloc */
#define ERTS_ALC_N_MIN_A_TEMPORARY (5)
#define ERTS_ALC_N_MAX_A_TEMPORARY (23)

/* Type numbers used for sl_alloc */
#define ERTS_ALC_N_MIN_A_SHORT_LIVED (24)
#define ERTS_ALC_N_MAX_A_SHORT_LIVED (55)

/* Type numbers used for std_alloc */
#define ERTS_ALC_N_MIN_A_STANDARD (56)
#define ERTS_ALC_N_MAX_A_STANDARD (90)

/* Type numbers used for ll_alloc */
#define ERTS_ALC_N_MIN_A_LONG_LIVED (91)
#define ERTS_ALC_N_MAX_A_LONG_LIVED (130)

/* Type numbers used for eheap_alloc */
#define ERTS_ALC_N_MIN_A_EHEAP (131)
#define ERTS_ALC_N_MAX_A_EHEAP (134)

/* Type numbers used for ets_alloc */
#define ERTS_ALC_N_MIN_A_ETS (135)
#define ERTS_ALC_N_MAX_A_ETS (143)

/* Type numbers used for fix_alloc */
#define ERTS_ALC_N_MIN_A_FIXED_SIZE (144)
#define ERTS_ALC_N_MAX_A_FIXED_SIZE (149)

/* Type numbers used for binary_alloc */
#define ERTS_ALC_N_MIN_A_BINARY (150)
#define ERTS_ALC_N_MAX_A_BINARY (151)

/* Type numbers used for driver_alloc */
#define ERTS_ALC_N_MIN_A_DRIVER (152)
#define ERTS_ALC_N_MAX_A_DRIVER (169)

#define ERTS_ALC_N_MAX (169)


/* --- Multi thread use of allocators -------------------------------------- */

#define ERTS_ALC_MTA_SYSTEM (1)
#define ERTS_ALC_MTA_TEMPORARY (0)
#define ERTS_ALC_MTA_SHORT_LIVED (0)
#define ERTS_ALC_MTA_STANDARD (0)
#define ERTS_ALC_MTA_LONG_LIVED (0)
#define ERTS_ALC_MTA_EHEAP (0)
#define ERTS_ALC_MTA_ETS (0)
#define ERTS_ALC_MTA_FIXED_SIZE (0)
#define ERTS_ALC_MTA_BINARY (1)
#define ERTS_ALC_MTA_DRIVER (1)


/* --- Types --------------------------------------------------------------- */

typedef Uint32 ErtsAlcType_t; /* The type used for memory types */

#define ERTS_ALC_T_INVALID (0)

#define ERTS_ALC_T_UNDEF (177)
#define ERTS_ALC_T_NBIF_TABLE (305)
#define ERTS_ALC_T_INFO_DSBUF (433)
#define ERTS_ALC_T_PUTENV_STR (561)
#define ERTS_ALC_T_TMP_HEAP (658)
#define ERTS_ALC_T_MSG_ROOTS (786)
#define ERTS_ALC_T_ROOTSET (914)
#define ERTS_ALC_T_LOADER_TMP (1106)
#define ERTS_ALC_T_NC_TMP (1202)
#define ERTS_ALC_T_TMP (1330)
#define ERTS_ALC_T_DCTRL_BUF (1458)
#define ERTS_ALC_T_TMP_DIST_BUF (1586)
#define ERTS_ALC_T_ESTACK (1714)
#define ERTS_ALC_T_DB_TMP (1826)
#define ERTS_ALC_T_DB_MC_STK (1954)
#define ERTS_ALC_T_DB_MS_CMPL_HEAP (2082)
#define ERTS_ALC_T_LOGGER_DSBUF (2226)
#define ERTS_ALC_T_TMP_DSBUF (2354)
#define ERTS_ALC_T_DDLL_TMP_BUF (2482)
#define ERTS_ALC_T_RE_TMP_BUF (2610)
#define ERTS_ALC_T_TEMP_TERM (2738)
#define ERTS_ALC_T_SYS_READ_BUF (2866)
#define ERTS_ALC_T_ENVIRONMENT (2994)
#define ERTS_ALC_T_PEND_SUSPEND (3091)
#define ERTS_ALC_T_PROC_LIST (3219)
#define ERTS_ALC_T_EXTRA_ROOT (3347)
#define ERTS_ALC_T_PREPARED_CODE (3539)
#define ERTS_ALC_T_SL_BIF_TIMER (3603)
#define ERTS_ALC_T_DB_FIXATION (3747)
#define ERTS_ALC_T_DB_FIX_DEL (3875)
#define ERTS_ALC_T_DB_MS_RUN_HEAP (4003)
#define ERTS_ALC_T_DB_PROC_CLEANUP (4131)
#define ERTS_ALC_T_PORT_TASK (4275)
#define ERTS_ALC_T_PT_HNDL_LIST (4403)
#define ERTS_ALC_T_MISC_OP_LIST (4531)
#define ERTS_ALC_T_PORT_NAMES (4659)
#define ERTS_ALC_T_PTAB_LIST_DEL (4755)
#define ERTS_ALC_T_PTAB_LIST_CNKI (4883)
#define ERTS_ALC_T_PTAB_LIST_PIDS (5011)
#define ERTS_ALC_T_RE_SUBJECT (5171)
#define ERTS_ALC_T_RE_STACK (5299)
#define ERTS_ALC_T_UNICODE_BUFFER (5427)
#define ERTS_ALC_T_BINARY_BUFFER (5555)
#define ERTS_ALC_T_TMP_CPU_IDS (5683)
#define ERTS_ALC_T_EXT_TERM_DATA (5779)
#define ERTS_ALC_T_CODE_IX_LOCK_Q (5939)
#define ERTS_ALC_T_BUSY_CALLER_TAB (6067)
#define ERTS_ALC_T_BUSY_CALLER (6195)
#define ERTS_ALC_T_THR_Q_SL (6323)
#define ERTS_ALC_T_ETHR_SL (6451)
#define ERTS_ALC_T_AINFO_REQ (6579)
#define ERTS_ALC_T_SCHED_WTIME_REQ (6707)
#define ERTS_ALC_T_GC_INFO_REQ (6835)
#define ERTS_ALC_T_FD_LIST (6963)
#define ERTS_ALC_T_POLLSET_UPDREQ (7091)
#define ERTS_ALC_T_REG_PROC (7188)
#define ERTS_ALC_T_LINK_LH (7316)
#define ERTS_ALC_T_SUSPEND_MON (7444)
#define ERTS_ALC_T_LL_BIF_TIMER (7572)
#define ERTS_ALC_T_REG_TABLE (7732)
#define ERTS_ALC_T_FUN_TABLE (7892)
#define ERTS_ALC_T_DIST_TABLE (7988)
#define ERTS_ALC_T_NODE_TABLE (8116)
#define ERTS_ALC_T_MODULE_REFS (8276)
#define ERTS_ALC_T_DCACHE (8372)
#define ERTS_ALC_T_DIST_ENTRY (8500)
#define ERTS_ALC_T_NODE_ENTRY (8628)
#define ERTS_ALC_T_ARG_REG (8724)
#define ERTS_ALC_T_PROC_DICT (8852)
#define ERTS_ALC_T_CALLS_BUF (8980)
#define ERTS_ALC_T_BPD (9140)
#define ERTS_ALC_T_LINEBUF (9268)
#define ERTS_ALC_T_IOQ (9396)
#define ERTS_ALC_T_BITS_BUF (9524)
#define ERTS_ALC_T_DB_NTAB_ENT (9636)
#define ERTS_ALC_T_DDLL_HANDLE (9780)
#define ERTS_ALC_T_NODES_MON (9876)
#define ERTS_ALC_T_RE_HEAP (10036)
#define ERTS_ALC_T_PSD (10132)
#define ERTS_ALC_T_PRTSD (10292)
#define ERTS_ALC_T_ZLIB (10420)
#define ERTS_ALC_T_PORT_DATA_HEAP (10548)
#define ERTS_ALC_T_THR_Q (10676)
#define ERTS_ALC_T_ETHR_STD (10804)
#define ERTS_ALC_T_DDLL_PROCESS (10932)
#define ERTS_ALC_T_MONITOR_LH (11028)
#define ERTS_ALC_T_NLINK_LH (11156)
#define ERTS_ALC_T_DB_HEIR_DATA (11300)
#define ERTS_ALC_T_FD_ENTRY_BUF (11444)
#define ERTS_ALC_T_PRT_REP_EXIT (11572)
#define ERTS_ALC_T_ATOM (11749)
#define ERTS_ALC_T_MODULE (11861)
#define ERTS_ALC_T_FUN_ENTRY (11989)
#define ERTS_ALC_T_ATOM_TXT (12133)
#define ERTS_ALC_T_BIF_TIMER_TABLE (12213)
#define ERTS_ALC_T_ATOM_TABLE (12389)
#define ERTS_ALC_T_EXPORT_TABLE (12501)
#define ERTS_ALC_T_MODULE_TABLE (12629)
#define ERTS_ALC_T_TAINT (12757)
#define ERTS_ALC_T_PROC_TABLE (12821)
#define ERTS_ALC_T_PORT_TABLE (12981)
#define ERTS_ALC_T_TIMER_WHEEL (13109)
#define ERTS_ALC_T_ASYNC_DATA (13237)
#define ERTS_ALC_T_DB_TABLES (13349)
#define ERTS_ALC_T_INSTR_INFO (13493)
#define ERTS_ALC_T_SCHDLR_SLP_INFO (13621)
#define ERTS_ALC_T_RUNQS (13749)
#define ERTS_ALC_T_DDLL_ERRCODES (13877)
#define ERTS_ALC_T_PRE_ALLOC_DATA (14005)
#define ERTS_ALC_T_CPUDATA (14133)
#define ERTS_ALC_T_CPU_GRPS_MAP (14261)
#define ERTS_ALC_T_AUX_WORK_TMO (14389)
#define ERTS_ALC_T_MISC_AUX_WORK_Q (14517)
#define ERTS_ALC_T_PROC_INTERVAL (14645)
#define ERTS_ALC_T_THR_Q_LL (14773)
#define ERTS_ALC_T_ETHR_LL (14901)
#define ERTS_ALC_T_CODE (15061)
#define ERTS_ALC_T_DB_MS_PSDO_PROC (15141)
#define ERTS_ALC_T_SCHDLR_DATA (15285)
#define ERTS_ALC_T_LL_TEMP_TERM (15413)
#define ERTS_ALC_T_EXPORT (15573)
#define ERTS_ALC_T_DRV_TAB (15669)
#define ERTS_ALC_T_DRV_EV_STATE (15797)
#define ERTS_ALC_T_POLLSET (15925)
#define ERTS_ALC_T_POLL_FDS (16053)
#define ERTS_ALC_T_POLL_RES_EVS (16181)
#define ERTS_ALC_T_FD_STATUS (16309)
#define ERTS_ALC_T_SELECT_FDS (16437)
#define ERTS_ALC_T_FD_TAB (16565)
#define ERTS_ALC_T_CS_PROG_PATH (16693)
#define ERTS_ALC_T_BEAM_REGISTER (16790)
#define ERTS_ALC_T_HEAP (16918)
#define ERTS_ALC_T_OLD_HEAP (17046)
#define ERTS_ALC_T_HEAP_FRAG (17174)
#define ERTS_ALC_T_DB_TABLE (17319)
#define ERTS_ALC_T_DB_SEG (17447)
#define ERTS_ALC_T_DB_SEG_TAB (17575)
#define ERTS_ALC_T_DB_STK (17703)
#define ERTS_ALC_T_DB_TRANS_TAB (17831)
#define ERTS_ALC_T_DB_SEL_LIST (17959)
#define ERTS_ALC_T_DB_DMC_ERROR (18087)
#define ERTS_ALC_T_DB_DMC_ERR_INFO (18215)
#define ERTS_ALC_T_DB_TERM (18343)
#define ERTS_ALC_T_PROC (18456)
#define ERTS_ALC_T_MSG_REF (18584)
#define ERTS_ALC_T_MONITOR_SH (18712)
#define ERTS_ALC_T_NLINK_SH (18840)
#define ERTS_ALC_T_DRV_EV_D_STATE (19000)
#define ERTS_ALC_T_DRV_SEL_D_STATE (19128)
#define ERTS_ALC_T_DRV_BINARY (19273)
#define ERTS_ALC_T_BINARY (19401)
#define ERTS_ALC_T_PORT (19514)
#define ERTS_ALC_T_DRV (19642)
#define ERTS_ALC_T_DRIVER (19770)
#define ERTS_ALC_T_DRV_CMD_DATA (19898)
#define ERTS_ALC_T_DRV_CTRL_DATA (20026)
#define ERTS_ALC_T_DRV_CALL_DATA (20154)
#define ERTS_ALC_T_NIF (20282)
#define ERTS_ALC_T_PORT_DATA_LOCK (20410)
#define ERTS_ALC_T_DRV_THR_OPTS (20538)
#define ERTS_ALC_T_DRV_TID (20666)
#define ERTS_ALC_T_DRV_MTX (20794)
#define ERTS_ALC_T_DRV_CND (20922)
#define ERTS_ALC_T_DRV_RWLCK (21050)
#define ERTS_ALC_T_DRV_TSD (21178)
#define ERTS_ALC_T_THR_Q_EL (21306)
#define ERTS_ALC_T_THR_Q_EL_SL (21434)
#define ERTS_ALC_T_MISC_AUX_WORK (21562)
#define ERTS_ALC_T_ASYNC (21690)


/* --- Field sizes, masks, and shifts -------------------------------------- */

#define ERTS_ALC_A_BITS (4)
#define ERTS_ALC_C_BITS (3)
#define ERTS_ALC_N_BITS (8)
#define ERTS_ALC_T_BITS (15)

#define ERTS_ALC_A_MASK (15)
#define ERTS_ALC_C_MASK (7)
#define ERTS_ALC_N_MASK (255)
#define ERTS_ALC_T_MASK (32767)

#define ERTS_ALC_A_SHIFT (0)
#define ERTS_ALC_C_SHIFT (4)
#define ERTS_ALC_N_SHIFT (7)


/* --- Mappings ------------------------------------------------------------ */

/* type -> type number */
#define ERTS_ALC_T2N(T) (((T) >> ERTS_ALC_N_SHIFT) & ERTS_ALC_N_MASK)

/* type -> allocator number */
#define ERTS_ALC_T2A(T) (((T) >> ERTS_ALC_A_SHIFT) & ERTS_ALC_A_MASK)

/* type -> class number */
#define ERTS_ALC_T2C(T) (((T) >> ERTS_ALC_C_SHIFT) & ERTS_ALC_C_MASK)

/* type number -> type */
#define ERTS_ALC_N2T(N) (erts_alc_n2t[(N)])

/* type number -> type description */
#define ERTS_ALC_N2TD(N) (erts_alc_n2td[(N)])

/* type -> type description */
#define ERTS_ALC_T2TD(T) (ERTS_ALC_N2TD(ERTS_ALC_T2N((T))))

/* class number -> class description */
#define ERTS_ALC_C2CD(C) (erts_alc_c2cd[(C)])

/* allocator number -> allocator description */
#define ERTS_ALC_A2AD(A) (erts_alc_a2ad[(A)])

extern const ErtsAlcType_t erts_alc_n2t[];
extern const char *erts_alc_n2td[];
extern const char *erts_alc_c2cd[];
extern const char *erts_alc_a2ad[];

#ifdef ERTS_ALC_INTERNAL__

const ErtsAlcType_t erts_alc_n2t[] = {
  ERTS_ALC_T_INVALID,
  ERTS_ALC_T_UNDEF,
  ERTS_ALC_T_NBIF_TABLE,
  ERTS_ALC_T_INFO_DSBUF,
  ERTS_ALC_T_PUTENV_STR,
  ERTS_ALC_T_TMP_HEAP,
  ERTS_ALC_T_MSG_ROOTS,
  ERTS_ALC_T_ROOTSET,
  ERTS_ALC_T_LOADER_TMP,
  ERTS_ALC_T_NC_TMP,
  ERTS_ALC_T_TMP,
  ERTS_ALC_T_DCTRL_BUF,
  ERTS_ALC_T_TMP_DIST_BUF,
  ERTS_ALC_T_ESTACK,
  ERTS_ALC_T_DB_TMP,
  ERTS_ALC_T_DB_MC_STK,
  ERTS_ALC_T_DB_MS_CMPL_HEAP,
  ERTS_ALC_T_LOGGER_DSBUF,
  ERTS_ALC_T_TMP_DSBUF,
  ERTS_ALC_T_DDLL_TMP_BUF,
  ERTS_ALC_T_RE_TMP_BUF,
  ERTS_ALC_T_TEMP_TERM,
  ERTS_ALC_T_SYS_READ_BUF,
  ERTS_ALC_T_ENVIRONMENT,
  ERTS_ALC_T_PEND_SUSPEND,
  ERTS_ALC_T_PROC_LIST,
  ERTS_ALC_T_EXTRA_ROOT,
  ERTS_ALC_T_PREPARED_CODE,
  ERTS_ALC_T_SL_BIF_TIMER,
  ERTS_ALC_T_DB_FIXATION,
  ERTS_ALC_T_DB_FIX_DEL,
  ERTS_ALC_T_DB_MS_RUN_HEAP,
  ERTS_ALC_T_DB_PROC_CLEANUP,
  ERTS_ALC_T_PORT_TASK,
  ERTS_ALC_T_PT_HNDL_LIST,
  ERTS_ALC_T_MISC_OP_LIST,
  ERTS_ALC_T_PORT_NAMES,
  ERTS_ALC_T_PTAB_LIST_DEL,
  ERTS_ALC_T_PTAB_LIST_CNKI,
  ERTS_ALC_T_PTAB_LIST_PIDS,
  ERTS_ALC_T_RE_SUBJECT,
  ERTS_ALC_T_RE_STACK,
  ERTS_ALC_T_UNICODE_BUFFER,
  ERTS_ALC_T_BINARY_BUFFER,
  ERTS_ALC_T_TMP_CPU_IDS,
  ERTS_ALC_T_EXT_TERM_DATA,
  ERTS_ALC_T_CODE_IX_LOCK_Q,
  ERTS_ALC_T_BUSY_CALLER_TAB,
  ERTS_ALC_T_BUSY_CALLER,
  ERTS_ALC_T_THR_Q_SL,
  ERTS_ALC_T_ETHR_SL,
  ERTS_ALC_T_AINFO_REQ,
  ERTS_ALC_T_SCHED_WTIME_REQ,
  ERTS_ALC_T_GC_INFO_REQ,
  ERTS_ALC_T_FD_LIST,
  ERTS_ALC_T_POLLSET_UPDREQ,
  ERTS_ALC_T_REG_PROC,
  ERTS_ALC_T_LINK_LH,
  ERTS_ALC_T_SUSPEND_MON,
  ERTS_ALC_T_LL_BIF_TIMER,
  ERTS_ALC_T_REG_TABLE,
  ERTS_ALC_T_FUN_TABLE,
  ERTS_ALC_T_DIST_TABLE,
  ERTS_ALC_T_NODE_TABLE,
  ERTS_ALC_T_MODULE_REFS,
  ERTS_ALC_T_DCACHE,
  ERTS_ALC_T_DIST_ENTRY,
  ERTS_ALC_T_NODE_ENTRY,
  ERTS_ALC_T_ARG_REG,
  ERTS_ALC_T_PROC_DICT,
  ERTS_ALC_T_CALLS_BUF,
  ERTS_ALC_T_BPD,
  ERTS_ALC_T_LINEBUF,
  ERTS_ALC_T_IOQ,
  ERTS_ALC_T_BITS_BUF,
  ERTS_ALC_T_DB_NTAB_ENT,
  ERTS_ALC_T_DDLL_HANDLE,
  ERTS_ALC_T_NODES_MON,
  ERTS_ALC_T_RE_HEAP,
  ERTS_ALC_T_PSD,
  ERTS_ALC_T_PRTSD,
  ERTS_ALC_T_ZLIB,
  ERTS_ALC_T_PORT_DATA_HEAP,
  ERTS_ALC_T_THR_Q,
  ERTS_ALC_T_ETHR_STD,
  ERTS_ALC_T_DDLL_PROCESS,
  ERTS_ALC_T_MONITOR_LH,
  ERTS_ALC_T_NLINK_LH,
  ERTS_ALC_T_DB_HEIR_DATA,
  ERTS_ALC_T_FD_ENTRY_BUF,
  ERTS_ALC_T_PRT_REP_EXIT,
  ERTS_ALC_T_ATOM,
  ERTS_ALC_T_MODULE,
  ERTS_ALC_T_FUN_ENTRY,
  ERTS_ALC_T_ATOM_TXT,
  ERTS_ALC_T_BIF_TIMER_TABLE,
  ERTS_ALC_T_ATOM_TABLE,
  ERTS_ALC_T_EXPORT_TABLE,
  ERTS_ALC_T_MODULE_TABLE,
  ERTS_ALC_T_TAINT,
  ERTS_ALC_T_PROC_TABLE,
  ERTS_ALC_T_PORT_TABLE,
  ERTS_ALC_T_TIMER_WHEEL,
  ERTS_ALC_T_ASYNC_DATA,
  ERTS_ALC_T_DB_TABLES,
  ERTS_ALC_T_INSTR_INFO,
  ERTS_ALC_T_SCHDLR_SLP_INFO,
  ERTS_ALC_T_RUNQS,
  ERTS_ALC_T_DDLL_ERRCODES,
  ERTS_ALC_T_PRE_ALLOC_DATA,
  ERTS_ALC_T_CPUDATA,
  ERTS_ALC_T_CPU_GRPS_MAP,
  ERTS_ALC_T_AUX_WORK_TMO,
  ERTS_ALC_T_MISC_AUX_WORK_Q,
  ERTS_ALC_T_PROC_INTERVAL,
  ERTS_ALC_T_THR_Q_LL,
  ERTS_ALC_T_ETHR_LL,
  ERTS_ALC_T_CODE,
  ERTS_ALC_T_DB_MS_PSDO_PROC,
  ERTS_ALC_T_SCHDLR_DATA,
  ERTS_ALC_T_LL_TEMP_TERM,
  ERTS_ALC_T_EXPORT,
  ERTS_ALC_T_DRV_TAB,
  ERTS_ALC_T_DRV_EV_STATE,
  ERTS_ALC_T_POLLSET,
  ERTS_ALC_T_POLL_FDS,
  ERTS_ALC_T_POLL_RES_EVS,
  ERTS_ALC_T_FD_STATUS,
  ERTS_ALC_T_SELECT_FDS,
  ERTS_ALC_T_FD_TAB,
  ERTS_ALC_T_CS_PROG_PATH,
  ERTS_ALC_T_BEAM_REGISTER,
  ERTS_ALC_T_HEAP,
  ERTS_ALC_T_OLD_HEAP,
  ERTS_ALC_T_HEAP_FRAG,
  ERTS_ALC_T_DB_TABLE,
  ERTS_ALC_T_DB_SEG,
  ERTS_ALC_T_DB_SEG_TAB,
  ERTS_ALC_T_DB_STK,
  ERTS_ALC_T_DB_TRANS_TAB,
  ERTS_ALC_T_DB_SEL_LIST,
  ERTS_ALC_T_DB_DMC_ERROR,
  ERTS_ALC_T_DB_DMC_ERR_INFO,
  ERTS_ALC_T_DB_TERM,
  ERTS_ALC_T_PROC,
  ERTS_ALC_T_MSG_REF,
  ERTS_ALC_T_MONITOR_SH,
  ERTS_ALC_T_NLINK_SH,
  ERTS_ALC_T_DRV_EV_D_STATE,
  ERTS_ALC_T_DRV_SEL_D_STATE,
  ERTS_ALC_T_DRV_BINARY,
  ERTS_ALC_T_BINARY,
  ERTS_ALC_T_PORT,
  ERTS_ALC_T_DRV,
  ERTS_ALC_T_DRIVER,
  ERTS_ALC_T_DRV_CMD_DATA,
  ERTS_ALC_T_DRV_CTRL_DATA,
  ERTS_ALC_T_DRV_CALL_DATA,
  ERTS_ALC_T_NIF,
  ERTS_ALC_T_PORT_DATA_LOCK,
  ERTS_ALC_T_DRV_THR_OPTS,
  ERTS_ALC_T_DRV_TID,
  ERTS_ALC_T_DRV_MTX,
  ERTS_ALC_T_DRV_CND,
  ERTS_ALC_T_DRV_RWLCK,
  ERTS_ALC_T_DRV_TSD,
  ERTS_ALC_T_THR_Q_EL,
  ERTS_ALC_T_THR_Q_EL_SL,
  ERTS_ALC_T_MISC_AUX_WORK,
  ERTS_ALC_T_ASYNC,
  ERTS_ALC_T_INVALID
};

const char *erts_alc_n2td[] = {
  "invalid_type",
  "undefined",
  "nbif_tab",
  "info_dsbuf",
  "putenv_string",
  "tmp_heap",
  "msg_roots",
  "root_set",
  "loader_tmp",
  "nc_tmp",
  "tmp",
  "dctrl_buf",
  "tmp_dist_buf",
  "estack",
  "db_tmp",
  "db_mc_stack",
  "db_match_spec_cmpl_heap",
  "logger_dsbuf",
  "tmp_dsbuf",
  "ddll_tmp_buf",
  "re_tmp_buf",
  "temp_term",
  "sys_read_buf",
  "environment",
  "pending_suspend",
  "proc_list",
  "extra_root",
  "prepared_code",
  "bif_timer_sl",
  "db_fixation",
  "fixed_del",
  "db_match_spec_run_heap",
  "db_proc_cleanup_state",
  "port_task",
  "port_task_handle_list",
  "misc_op_list",
  "port_names",
  "ptab_list_deleted_el",
  "ptab_list_chunk_info",
  "ptab_list_pids",
  "re_subject",
  "re_stack",
  "unicode_buffer",
  "binary_buffer",
  "tmp_cpu_ids",
  "external_term_data",
  "code_ix_lock_q",
  "busy_caller_table",
  "busy_caller",
  "short_lived_thr_queue",
  "ethread_short_lived",
  "alloc_info_request",
  "sched_wall_time_request",
  "gc_info_request",
  "fd_list",
  "pollset_update_req",
  "reg_proc",
  "link_lh",
  "suspend_monitor",
  "bif_timer_ll",
  "reg_tab",
  "fun_tab",
  "dist_tab",
  "node_tab",
  "module_refs",
  "dcache",
  "dist_entry",
  "node_entry",
  "arg_reg",
  "proc_dict",
  "calls_buf",
  "bpd",
  "line_buf",
  "io_queue",
  "bits_buf",
  "db_named_table_entry",
  "ddll_handle",
  "nodes_monitor",
  "re_heap",
  "process_specific_data",
  "port_specific_data",
  "zlib",
  "port_data_heap",
  "thr_queue",
  "ethread_standard",
  "ddll_processes",
  "monitor_lh",
  "nlink_lh",
  "db_heir_data",
  "fd_entry_buf",
  "port_report_exit",
  "atom_entry",
  "module_entry",
  "fun_entry",
  "atom_text",
  "bif_timer_table",
  "atom_tab",
  "export_tab",
  "module_tab",
  "taint_list",
  "proc_tab",
  "port_tab",
  "timer_wheel",
  "internal_async_data",
  "db_tabs",
  "instr_info",
  "scheduler_sleep_info",
  "run_queues",
  "ddll_errcodes",
  "pre_alloc_data",
  "cpu_data",
  "cpu_groups_map",
  "aux_work_timeouts",
  "misc_aux_work_q",
  "process_interval",
  "long_lived_thr_queue",
  "ethread_long_lived",
  "code",
  "db_match_pseudo_proc",
  "scheduler_data",
  "ll_temp_term",
  "export_entry",
  "drv_tab",
  "driver_event_state",
  "pollset",
  "poll_fds",
  "poll_result_events",
  "fd_status",
  "select_fds",
  "fd_tab",
  "cs_prog_path",
  "beam_register",
  "heap",
  "old_heap",
  "heap_frag",
  "db_tab",
  "db_segment",
  "db_segment_tab",
  "db_stack",
  "db_trans_tab",
  "db_select_list",
  "db_dmc_error",
  "db_dmc_error_info",
  "db_term",
  "proc",
  "msg_ref",
  "monitor_sh",
  "nlink_sh",
  "driver_event_data_state",
  "driver_select_data_state",
  "drv_binary",
  "binary",
  "port",
  "drv_internal",
  "driver",
  "driver_command_data",
  "driver_control_data",
  "driver_call_data",
  "nif_internal",
  "port_data_lock",
  "driver_thread_opts",
  "driver_tid",
  "driver_mutex",
  "driver_cond",
  "driver_rwlock",
  "driver_tsd",
  "thr_q_element",
  "sl_thr_q_element",
  "misc_aux_work",
  "async",
  NULL
};

const char *erts_alc_c2cd[] = {
  "invalid_class",
  "process_data",
  "ets_data",
  "system_data",
  "binary_data",
  "code_data",
  "atom_data",
  NULL
};

const char *erts_alc_a2ad[] = {
  "invalid_allocator",
  "sys_alloc",
  "temp_alloc",
  "sl_alloc",
  "std_alloc",
  "ll_alloc",
  "eheap_alloc",
  "ets_alloc",
  "fix_alloc",
  "binary_alloc",
  "driver_alloc",
  NULL
};

#endif /* #ifdef ERTS_ALC_INTERNAL__ */


/* ------------------------------------------------------------------------- */
#endif /* #ifndef ERL_ALLOC_TYPES_H__ */
